#ifdef __IAR_SYSTEMS_ICC__
 #include "../libs/stm32f10x_rcc.h"
 #include "../libs/stm32f10x_nvic.h"
 #include "../libs/stm32f10x_flash.h"
 #include "../libs/stm32f10x_systick.h"
 #include "../libs/stm32f10x_gpio.h"
 #include "../libs/stm32f10x_usart.h"
 #include "../libs/stm32f10x_i2c.h"
 #include "../libs/stm32f10x_tim.h"
 #include "../libs/stm32f10x_iwdg.h"
#else
 #ifdef __CC_ARM
  #include <stm32f10x_lib.h>  /* STM32F10x Library Definitions      */
 #else
  #error "unknown compiler"
 #endif
#endif



#include "../config/OS_STM32.h"

OS_PACKED typedef struct motors {
    U16   motor[4];
} OS_PACKED_ATTR MOTORS;

OS_PACKED typedef struct motion {
    S16    accel_x;
    S16    accel_y;
    S16    accel_z;
    S16    gyro_x;
    S16    gyro_y;
    S16    gyro_z;
    S16    mag_x;
    S16    mag_y;
    S16    mag_z;
    S16    rsvd;
} OS_PACKED_ATTR MOTION;

OS_PACKED typedef struct motionl {
    S32    accel_x;
    S32    accel_y;
    S32    accel_z;
    S32    gyro_x;
    S32    gyro_y;
    S32    gyro_z;
    S32    mag_x;
    S32    mag_y;
    S32    mag_z;
    S32    rsvd;
} OS_PACKED_ATTR MOTIONL;

OS_PACKED typedef struct channel {
    U16    channel[7];
    U16    rsvd;
} OS_PACKED_ATTR CHANNEL;

enum axis {
    CH_throttle = 0,  // = Gas / Hhe
    CH_roll     = 1,  // = links/rechts neigen
    CH_pitch    = 2,  // = vorn/hinten neigen
    CH_yaw      = 3,  // = um eigene Achse seitlich drehen
};

#include "modules/calc.h"

#include "modules/imu.h"

#include "modules/motors.h"

#include "modules/control.h"




