
#include "imu_MPU9150.h"

// used config
#define GYRO_FS_SEL      MPU9150_FS_SEL_250
#define ACCEL_AFS_SEL    MPU9150_AFS_SEL_2
#define IMU_UPDATE_FREQ  100


typedef struct c_val {
    S16    acc_x, acc_y, acc_z, gyr_pitch, gyr_roll, gyr_yaw;
    S16    usr_pitch, usr_roll, usr_yaw, usr_z;
} C_VAL;

typedef struct act {
    S16    pitch;
    S16    roll;
    S16    yaw;
} ACT;

void calc(C_VAL *curr, ACT *act);
void calc_reset(void);

/************************************************************
*         <-     ->
*          o     o
*
*          o     o
*         <-     ->
*
*
*        +682             +341
*          |                |
*   +341 --+-- -341  +341 --+-- -341
*          |                |
*          0              -341
*
************************************************************/

#if   (GYRO_FS_SEL == MPU9150_FS_SEL_250)   
 #define IMU_DEG_PER_LSB  (float)((2 * 250.0)  / 65536.0)
#elif (GYRO_FS_SEL == MPU9150_FS_SEL_500)   
 #define IMU_DEG_PER_LSB  (float)((2 * 500.0)  / 65536.0)
#elif (GYRO_FS_SEL == MPU9150_FS_SEL_1000)  
 #define IMU_DEG_PER_LSB  (float)((2 * 1000.0) / 65536.0)
#elif (GYRO_FS_SEL == MPU9150_FS_SEL_2000)  
 #define IMU_DEG_PER_LSB  (float)((2 * 2000.0) / 65536.0)
#endif

#if   (ACCEL_AFS_SEL == MPU9150_AFS_SEL_2)  
 #define IMU_G_PER_LSB    (float)((2 * 2)  / 65536.0)
#elif (ACCEL_AFS_SEL == MPU9150_AFS_SEL_4)  
 #define IMU_G_PER_LSB    (float)((2 * 4)  / 65536.0)
#elif (ACCEL_AFS_SEL == MPU9150_AFS_SEL_8)  
 #define IMU_G_PER_LSB    (float)((2 * 8)  / 65536.0)
#elif (ACCEL_AFS_SEL == MPU9150_AFS_SEL_16) 
 #define IMU_G_PER_LSB    (float)((2 * 16) / 65536.0)
#endif


