#include "calc.h"

#define TIME_CON  0.01
#define ACCEL_CON 0.93
#define GYRO_CON  1.47
#define SEN_CON   0.95
#define P_CON     2.5
#define D_CON     0.5

S32  pitch_a=0, roll_a=0, yaw_a=0;

/**********************************************************************************
*            calc with MotionTracking & user-command for motor control            *
**********************************************************************************/
void calc(C_VAL *curr, ACT *act)
{
    // motion calc
    pitch_a  = SEN_CON * (pitch_a + TIME_CON * curr->gyr_pitch) + ( 1 - SEN_CON ) * -curr->acc_y;
    roll_a   = SEN_CON * (roll_a + TIME_CON * curr->gyr_roll)  + ( 1 - SEN_CON ) *  curr->acc_x;
    yaw_a    = SEN_CON * (yaw_a + TIME_CON * curr->gyr_yaw);
	
    act->pitch = P_CON * (pitch_a - curr->usr_pitch) - D_CON * curr->gyr_pitch;
    act->roll  = P_CON * (roll_a  - curr->usr_roll)  - D_CON * curr->gyr_roll;
    act->yaw   = P_CON * (yaw_a   - curr->usr_yaw)   - D_CON * curr->gyr_yaw;
}

