#include "calc.h"


#define CUZ     2.00
#define CUP     0.50
#define CUR     0.50
#define CUY     0.50

#define LGP     0.999998
#define LGR     0.999998
#define LGY     0.999998

#define CGP     0.000002
#define CGR     0.000002
#define CGY     0.000002


void calc(C_VAL *curr, C_VAL *last, MOTORS *m)
{  
    // user control
    m->motor[0] = (U16)(curr->usr_z * CUZ - (curr->usr_pitch * CUP / 2) - (curr->usr_roll * CUR / 2) - (curr->usr_yaw * CUY / 2));
    m->motor[1] = (U16)(curr->usr_z * CUZ + (curr->usr_pitch * CUP / 2) - (curr->usr_roll * CUR / 2) + (curr->usr_yaw * CUY / 2));
    m->motor[2] = (U16)(curr->usr_z * CUZ - (curr->usr_pitch * CUP / 2) + (curr->usr_roll * CUR / 2) + (curr->usr_yaw * CUY / 2));
    m->motor[3] = (U16)(curr->usr_z * CUZ + (curr->usr_pitch * CUP / 2) + (curr->usr_roll * CUR / 2) - (curr->usr_yaw * CUY / 2));

    // stabilization
    m->motor[0] = m->motor[0] - (U16)(((last->gyr_pitch * LGP + curr->gyr_pitch * CGP) / 2) - ((last->gyr_roll * LGR + curr->gyr_roll * CGR) / 2) - ((last->gyr_yaw * LGY + curr->gyr_yaw * CGY) / 2));
    m->motor[1] = m->motor[1] + (U16)(((last->gyr_pitch * LGP + curr->gyr_pitch * CGP) / 2) - ((last->gyr_roll * LGR + curr->gyr_roll * CGR) / 2) + ((last->gyr_yaw * LGY + curr->gyr_yaw * CGY) / 2));
    m->motor[2] = m->motor[2] - (U16)(((last->gyr_pitch * LGP + curr->gyr_pitch * CGP) / 2) + ((last->gyr_roll * LGR + curr->gyr_roll * CGR) / 2) + ((last->gyr_yaw * LGY + curr->gyr_yaw * CGY) / 2));
    m->motor[3] = m->motor[3] + (U16)(((last->gyr_pitch * LGP + curr->gyr_pitch * CGP) / 2) + ((last->gyr_roll * LGR + curr->gyr_roll * CGR) / 2) - ((last->gyr_yaw * LGY + curr->gyr_yaw * CGY) / 2));

    // notice for next stabilization
    last->gyr_pitch = last->gyr_pitch * LGP + curr->gyr_pitch * CGP;
    last->gyr_roll  = last->gyr_roll  * LGR + curr->gyr_roll  * CGR;
    last->gyr_yaw   = last->gyr_yaw   * LGY + curr->gyr_yaw   * CGY;

}